Package com.google.protobuf

# Interface MessageLite.Builder

All Superinterfaces:
  `Cloneable`, `MessageLiteOrBuilder`

All Known Subinterfaces:
  `Message.Builder`

All Known Implementing Classes:
  `AbstractMessage.Builder`, `AbstractMessageLite.Builder`, `Any.Builder`, `Api.Builder`, `BoolValue.Builder`, `BytesValue.Builder`, `ClientWireProtocol.AttachToQuery.Builder`, `ClientWireProtocol.Authenticator.Builder`, `ClientWireProtocol.CancelQuery.Builder`, `ClientWireProtocol.CancelQueryResponse.Builder`, `ClientWireProtocol.ClientConnection.Builder`, `ClientWireProtocol.ClientConnection2.Builder`, `ClientWireProtocol.ClientConnection2Response.Builder`, `ClientWireProtocol.ClientConnectionGCM.Builder`, `ClientWireProtocol.ClientConnectionGCM2.Builder`, `ClientWireProtocol.ClientConnectionGCM2Response.Builder`, `ClientWireProtocol.ClientConnectionGCMResponse.Builder`, `ClientWireProtocol.ClientConnectionRefreshSession.Builder`, `ClientWireProtocol.ClientConnectionRefreshSessionResponse.Builder`, `ClientWireProtocol.ClientConnectionRefreshToken.Builder`, `ClientWireProtocol.ClientConnectionRefreshTokenResponse.Builder`, `ClientWireProtocol.ClientConnectionResponse.Builder`, `ClientWireProtocol.ClientConnectionSecurityToken.Builder`, `ClientWireProtocol.ClientConnectionSecurityTokenResponse.Builder`, `ClientWireProtocol.ClientConnectionSSO.Builder`, `ClientWireProtocol.ClientConnectionSSO2.Builder`, `ClientWireProtocol.ClientConnectionSSO2Response.Builder`, `ClientWireProtocol.ClientConnectionSSOResponse.Builder`, `ClientWireProtocol.CloseConnection.Builder`, `ClientWireProtocol.CloseResultSet.Builder`, `ClientWireProtocol.ConfirmationResponse.Builder`, `ClientWireProtocol.ExecuteExplain.Builder`, `ClientWireProtocol.ExecuteExplainForSpark.Builder`, `ClientWireProtocol.ExecuteExport.Builder`, `ClientWireProtocol.ExecuteExportResponse.Builder`, `ClientWireProtocol.ExecuteInlinePlan.Builder`, `ClientWireProtocol.ExecutePlan.Builder`, `ClientWireProtocol.ExecuteQuery.Builder`, `ClientWireProtocol.ExecuteQueryResponse.Builder`, `ClientWireProtocol.ExecuteUpdate.Builder`, `ClientWireProtocol.ExecuteUpdateResponse.Builder`, `ClientWireProtocol.ExplainPipelineRequest.Builder`, `ClientWireProtocol.ExplainPipelineResponse.Builder`, `ClientWireProtocol.ExplainPlan.Builder`, `ClientWireProtocol.ExplainResponseStringPlan.Builder`, `ClientWireProtocol.FetchAuthenticators.Builder`, `ClientWireProtocol.FetchAuthenticatorsResponse.Builder`, `ClientWireProtocol.FetchData.Builder`, `ClientWireProtocol.FetchDataResponse.Builder`, `ClientWireProtocol.FetchMetadata.Builder`, `ClientWireProtocol.FetchMetadataResponse.Builder`, `ClientWireProtocol.FetchSystemMetadata.Builder`, `ClientWireProtocol.FetchSystemMetadataResponse.Builder`, `ClientWireProtocol.FetchUpdateStatus.Builder`, `ClientWireProtocol.FetchUpdateStatusResponse.Builder`, `ClientWireProtocol.ForceExternal.Builder`, `ClientWireProtocol.GetSchema.Builder`, `ClientWireProtocol.GetSchemaResponse.Builder`, `ClientWireProtocol.KillQuery.Builder`, `ClientWireProtocol.KillQueryResponse.Builder`, `ClientWireProtocol.ListPlan.Builder`, `ClientWireProtocol.ListPlanResponse.Builder`, `ClientWireProtocol.OpenIDAuthenticator.Builder`, `ClientWireProtocol.QueryConcurrencyResponse.Builder`, `ClientWireProtocol.Request.Builder`, `ClientWireProtocol.ResultSet.Builder`, `ClientWireProtocol.SecondaryInterfaceList.Builder`, `ClientWireProtocol.SecurityToken.Builder`, `ClientWireProtocol.ServerVersion.Builder`, `ClientWireProtocol.SessionInfo.Builder`, `ClientWireProtocol.SetParameter.Builder`, `ClientWireProtocol.SetParameter.Concurrency.Builder`, `ClientWireProtocol.SetParameter.ForceExternal.Builder`, `ClientWireProtocol.SetParameter.MaxTempDiskLimit.Builder`, `ClientWireProtocol.SetParameter.MemoryTracing.Builder`, `ClientWireProtocol.SetParameter.Priority.Builder`, `ClientWireProtocol.SetParameter.PriorityAdjustFactor.Builder`, `ClientWireProtocol.SetParameter.PriorityAdjustTime.Builder`, `ClientWireProtocol.SetParameter.ResultSetColumnLimit.Builder`, `ClientWireProtocol.SetParameter.RowLimit.Builder`, `ClientWireProtocol.SetParameter.ServiceClassName.Builder`, `ClientWireProtocol.SetParameter.TimeLimit.Builder`, `ClientWireProtocol.SetSchema.Builder`, `ClientWireProtocol.TestConnection.Builder`, `DescriptorProtos.DescriptorProto.Builder`, `DescriptorProtos.DescriptorProto.ExtensionRange.Builder`, `DescriptorProtos.DescriptorProto.ReservedRange.Builder`, `DescriptorProtos.EnumDescriptorProto.Builder`, `DescriptorProtos.EnumDescriptorProto.EnumReservedRange.Builder`, `DescriptorProtos.EnumOptions.Builder`, `DescriptorProtos.EnumValueDescriptorProto.Builder`, `DescriptorProtos.EnumValueOptions.Builder`, `DescriptorProtos.ExtensionRangeOptions.Builder`, `DescriptorProtos.ExtensionRangeOptions.Declaration.Builder`, `DescriptorProtos.FeatureSet.Builder`, `DescriptorProtos.FeatureSetDefaults.Builder`, `DescriptorProtos.FeatureSetDefaults.FeatureSetEditionDefault.Builder`, `DescriptorProtos.FieldDescriptorProto.Builder`, `DescriptorProtos.FieldOptions.Builder`, `DescriptorProtos.FieldOptions.EditionDefault.Builder`, `DescriptorProtos.FieldOptions.FeatureSupport.Builder`, `DescriptorProtos.FileDescriptorProto.Builder`, `DescriptorProtos.FileDescriptorSet.Builder`, `DescriptorProtos.FileOptions.Builder`, `DescriptorProtos.GeneratedCodeInfo.Annotation.Builder`, `DescriptorProtos.GeneratedCodeInfo.Builder`, `DescriptorProtos.MessageOptions.Builder`, `DescriptorProtos.MethodDescriptorProto.Builder`, `DescriptorProtos.MethodOptions.Builder`, `DescriptorProtos.OneofDescriptorProto.Builder`, `DescriptorProtos.OneofOptions.Builder`, `DescriptorProtos.ServiceDescriptorProto.Builder`, `DescriptorProtos.ServiceOptions.Builder`, `DescriptorProtos.SourceCodeInfo.Builder`, `DescriptorProtos.SourceCodeInfo.Location.Builder`, `DescriptorProtos.UninterpretedOption.Builder`, `DescriptorProtos.UninterpretedOption.NamePart.Builder`, `DoubleValue.Builder`, `Duration.Builder`, `DynamicMessage.Builder`, `Empty.Builder`, `Enum.Builder`, `EnumValue.Builder`, `Field.Builder`, `FieldMask.Builder`, `FloatValue.Builder`, `GeneratedMessage.Builder`, `GeneratedMessage.ExtendableBuilder`, `GeneratedMessageLite.Builder`, `GeneratedMessageLite.ExtendableBuilder`, `GeneratedMessageV3.Builder`, `GeneratedMessageV3.ExtendableBuilder`, `Int32Value.Builder`, `Int64Value.Builder`, `JavaFeaturesProto.JavaFeatures.Builder`, `ListValue.Builder`, `MapEntry.Builder`, `Method.Builder`, `Mixin.Builder`, `Option.Builder`, `PluginProtos.CodeGeneratorRequest.Builder`, `PluginProtos.CodeGeneratorResponse.Builder`, `PluginProtos.CodeGeneratorResponse.File.Builder`, `PluginProtos.Version.Builder`, `SourceContext.Builder`, `StringValue.Builder`, `Struct.Builder`, `Timestamp.Builder`, `Type.Builder`, `UInt32Value.Builder`, `UInt64Value.Builder`, `UnknownFieldSet.Builder`, `Value.Builder`

Enclosing interface:
  `MessageLite`

public static interface MessageLite.Builder extends MessageLiteOrBuilder, Cloneable
Abstract interface implemented by Protocol Message builders.

## Method Summary

Modifier and Type
Method
Description
`MessageLite`
`build()`
Constructs the message based on the state of the Builder.
`MessageLite`
`buildPartial()`
Like `build()`, but does not throw an exception if the message is missing required fields.
`MessageLite.Builder`
`clear()`
Resets all fields to their default values.
`MessageLite.Builder`
`clone()`
Clones the Builder.
`boolean`
`mergeDelimitedFrom(InputStream input)`
Like `mergeFrom(InputStream)`, but does not read until EOF.
`boolean`
`mergeDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
Like `mergeDelimitedFrom(InputStream)` but supporting extensions.
`MessageLite.Builder`
`mergeFrom(byte[] data)`
Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder`
`mergeFrom(byte[] data, int off, int len)`
Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder`
`mergeFrom(byte[] data, int off, int len, ExtensionRegistryLite extensionRegistry)`
Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder`
`mergeFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder`
`mergeFrom(ByteString data)`
Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder`
`mergeFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder`
`mergeFrom(CodedInputStream input)`
Parses a message of this type from the input and merges it with this message.
`MessageLite.Builder`
`mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
Like `mergeFrom(CodedInputStream)`, but also parses extensions.
`MessageLite.Builder`
`mergeFrom(MessageLite other)`
Merge `other` into the message being built.
`MessageLite.Builder`
`mergeFrom(InputStream input)`
Parse a message of this type from `input` and merge it with the message being built.
`MessageLite.Builder`
`mergeFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
Parse a message of this type from `input` and merge it with the message being built.

### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

`getDefaultInstanceForType, isInitialized`

## Method Details

### clear

@CanIgnoreReturnValue MessageLite.Builder clear()
Resets all fields to their default values.

### build

MessageLite build()
Constructs the message based on the state of the Builder. Subsequent changes to the Builder will not affect the returned message.

Throws:
  `UninitializedMessageException` - The message is missing one or more required fields (i.e. `MessageLiteOrBuilder.isInitialized()` returns false). Use `buildPartial()` to bypass this check.

### buildPartial

MessageLite buildPartial()
Like `build()`, but does not throw an exception if the message is missing required fields. Instead, a partial message is returned. Subsequent changes to the Builder will not affect the returned message.

### clone

MessageLite.Builder clone()
Clones the Builder.

See Also:
  - `Object.clone()`

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(CodedInputStream input) throws IOException
Parses a message of this type from the input and merges it with this message.

Warning: This does not verify that all required fields are present in the input message. If you call `build()` without setting all required fields, it will throw an `UninitializedMessageException`, which is a `RuntimeException` and thus might not be caught. There are a few good ways to deal with this:

- Call `MessageLiteOrBuilder.isInitialized()` to verify that all required fields are set before building.
- Use `buildPartial()` to build, which ignores missing required fields.

Note: The caller should call `CodedInputStream.checkLastTagWas(int)` after calling this to verify that the last tag seen was the appropriate end-group tag, or zero for EOF.

Throws:
  `InvalidProtocolBufferException` - the bytes read are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.
  `IOException` - an I/O error reading from the stream

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry) throws IOException
Like `mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.

Throws:
  `InvalidProtocolBufferException` - the bytes read are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.
  `IOException` - an I/O error reading from the stream

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(ByteString data) throws InvalidProtocolBufferException
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(ByteString data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(byte[] data) throws InvalidProtocolBufferException
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(byte[] data, int off, int len) throws InvalidProtocolBufferException
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(byte[] data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(byte[] data, int off, int len, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(InputStream input) throws IOException
Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream)`. Note that this method always reads the entire input (unless it throws an exception). If you want it to stop earlier, you will need to wrap your input in some wrapper stream that limits reading. Or, use `MessageLite.writeDelimitedTo(OutputStream)` to write your message and `mergeDelimitedFrom(InputStream)` to read it.

Despite usually reading the entire input, this does not close the stream.

Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes read are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.
  `IOException` - an I/O error reading from the stream

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException
Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Returns:
  this
Throws:
  `IOException`

### mergeFrom

@CanIgnoreReturnValue MessageLite.Builder mergeFrom(MessageLite other)
Merge `other` into the message being built. `other` must have the exact same type as `this` (i.e. `getClass().equals(getDefaultInstanceForType().getClass())`).

Merging occurs as follows. For each field:
* For singular primitive fields, if the field is set in `other`, then `other`'s value overwrites the value in this message.
* For singular message fields, if the field is set in `other`, it is merged into the corresponding sub-message of this message using the same merging rules.
* For repeated fields, the elements in `other` are concatenated with the elements in this message. * For oneof groups, if the other message has one of the fields set, the group of this message is cleared and replaced by the field of the other message, so that the oneof constraint is preserved.

This is equivalent to the `Message::MergeFrom` method in C++.

### mergeDelimitedFrom

boolean mergeDelimitedFrom(InputStream input) throws IOException
Like `mergeFrom(InputStream)`, but does not read until EOF. Instead, the size of the message (encoded as a varint) is read first, then the message data. Use `MessageLite.writeDelimitedTo(OutputStream)` to write messages in this format.

Returns:
  true if successful, or false if the stream is at EOF when the method starts. Any other error (including reaching EOF during parsing) causes an exception to be thrown.
Throws:
  `InvalidProtocolBufferException` - the bytes read are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.
  `IOException` - an I/O error reading from the stream

### mergeDelimitedFrom

boolean mergeDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException
Like `mergeDelimitedFrom(InputStream)` but supporting extensions.

Returns:
  true if successful, or false if the stream is at EOF when the method starts. Any other error (including reaching EOF during parsing) causes an exception to be thrown.
Throws:
  `InvalidProtocolBufferException` - the bytes read are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.
  `IOException` - an I/O error reading from the stream